searchNodes=[{"doc":"Documentation for MarsExplorer .","ref":"MarsExplorer.html","title":"MarsExplorer","type":"module"},{"doc":"Hello world. Examples iex&gt; MarsExplorer . hello ( ) :world","ref":"MarsExplorer.html#hello/0","title":"MarsExplorer.hello/0","type":"function"},{"doc":"Module responsible for Mars Explorer CLI","ref":"MarsExplorer.CLI.html","title":"MarsExplorer.CLI","type":"module"},{"doc":"Receives the name of a file containing all the instructions of an exploration, executes them and displays the result Example iex&gt; MarsExplorer.CLI . main ( [ &quot;instructions.txt&quot; ] ) :ok 1 3 N 5 1 E","ref":"MarsExplorer.CLI.html#main/1","title":"MarsExplorer.CLI.main/1","type":"function"},{"doc":"Module responsible for managing a exploration","ref":"MarsExplorer.Exploration.html","title":"MarsExplorer.Exploration","type":"module"},{"doc":"Moves the probe forward one unit in the direction that it is facing, unless that position is past the limits of the grid. Examples A valid movement iex&gt; alias MarsExplorer . { Probe , HighlandGrid , Exploration } [ MarsExplorer.Probe , MarsExplorer.HighlandGrid , MarsExplorer.Exploration ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; exploration = % Exploration { ...&gt; grid : grid , ...&gt; probe : % Probe { north : 0 , east : 0 , direction : :north } ...&gt; } iex&gt; exploration |&gt; Exploration . move { :ok , % Exploration { grid : grid , probe : % Probe { north : 1 , east : 0 , direction : :north } } } An invalid movement: iex&gt; alias MarsExplorer . { Probe , HighlandGrid , Exploration } [ MarsExplorer.Probe , MarsExplorer.HighlandGrid , MarsExplorer.Exploration ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; exploration = % Exploration { ...&gt; grid : grid , ...&gt; probe : % Probe { north : 5 , east : 0 , direction : :north } ...&gt; } iex&gt; exploration |&gt; Exploration . move ( ) { :error , :at_grid_limit }","ref":"MarsExplorer.Exploration.html#move/1","title":"MarsExplorer.Exploration.move/1","type":"function"},{"doc":"Places a probe on a grid Examples When the probe is placed in a valid position iex&gt; alias MarsExplorer . { Probe , Exploration , HighlandGrid } [ MarsExplorer.Probe , MarsExplorer.Exploration , MarsExplorer.HighlandGrid ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; Exploration . place ( grid , %{ north : 0 , east : 0 , direction : :north } ) { :ok , % Exploration { grid : grid , probe : % Probe { north : 0 , east : 0 , direction : :north } } } When the probe is placed in a invalid position iex&gt; alias MarsExplorer . { Exploration , HighlandGrid } [ MarsExplorer.Exploration , MarsExplorer.HighlandGrid ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; Exploration . place ( grid , %{ north : 6 , east : 6 , direction : :north } ) { :error , :invalid_placement }","ref":"MarsExplorer.Exploration.html#place/2","title":"MarsExplorer.Exploration.place/2","type":"function"},{"doc":"Returns the probe's current position. Examples iex&gt; alias MarsExplorer . { Probe , HighlandGrid , Exploration } [ MarsExplorer.Probe , MarsExplorer.HighlandGrid , MarsExplorer.Exploration ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; exploration = % Exploration { ...&gt; grid : grid , ...&gt; probe : % Probe { north : 0 , east : 0 , direction : :north } ...&gt; } iex&gt; exploration |&gt; Exploration . report % Probe { north : 0 , east : 0 , direction : :north }","ref":"MarsExplorer.Exploration.html#report/1","title":"MarsExplorer.Exploration.report/1","type":"function"},{"doc":"Turns the probe left. Examples iex&gt; alias MarsExplorer . { Probe , HighlandGrid , Exploration } [ MarsExplorer.Probe , MarsExplorer.HighlandGrid , MarsExplorer.Exploration ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; exploration = % Exploration { ...&gt; grid : grid , ...&gt; probe : % Probe { north : 0 , east : 0 , direction : :north } ...&gt; } iex&gt; exploration |&gt; Exploration . turn_left { :ok , % Exploration { grid : grid , probe : % Probe { north : 0 , east : 0 , direction : :west } } }","ref":"MarsExplorer.Exploration.html#turn_left/1","title":"MarsExplorer.Exploration.turn_left/1","type":"function"},{"doc":"Turns the probe left. Examples iex&gt; alias MarsExplorer . { Probe , HighlandGrid , Exploration } [ MarsExplorer.Probe , MarsExplorer.HighlandGrid , MarsExplorer.Exploration ] iex&gt; grid = HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; exploration = % Exploration { ...&gt; grid : grid , ...&gt; probe : % Probe { north : 0 , east : 0 , direction : :north } ...&gt; } iex&gt; exploration |&gt; Exploration . turn_right { :ok , % Exploration { grid : grid , probe : % Probe { north : 0 , east : 0 , direction : :east } } }","ref":"MarsExplorer.Exploration.html#turn_right/1","title":"MarsExplorer.Exploration.turn_right/1","type":"function"},{"doc":"","ref":"MarsExplorer.Exploration.html#t:placement/0","title":"MarsExplorer.Exploration.placement/0","type":"type"},{"doc":"","ref":"MarsExplorer.Exploration.html#t:t/0","title":"MarsExplorer.Exploration.t/0","type":"type"},{"doc":"Module responsible for managing multiple explorations state","ref":"MarsExplorer.ExplorationsController.html","title":"MarsExplorer.ExplorationsController","type":"module"},{"doc":"Add a exploration to the concluded explorations list","ref":"MarsExplorer.ExplorationsController.html#add_exploration_to_explorations_list/1","title":"MarsExplorer.ExplorationsController.add_exploration_to_explorations_list/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MarsExplorer.ExplorationsController.html#child_spec/1","title":"MarsExplorer.ExplorationsController.child_spec/1","type":"function"},{"doc":"Cleans the concluded explorations list","ref":"MarsExplorer.ExplorationsController.html#clean_explorations/0","title":"MarsExplorer.ExplorationsController.clean_explorations/0","type":"function"},{"doc":"Get the concluded explorations list","ref":"MarsExplorer.ExplorationsController.html#get_explorations/0","title":"MarsExplorer.ExplorationsController.get_explorations/0","type":"function"},{"doc":"Get the explorations grid","ref":"MarsExplorer.ExplorationsController.html#get_grid/0","title":"MarsExplorer.ExplorationsController.get_grid/0","type":"function"},{"doc":"Get the running exploration","ref":"MarsExplorer.ExplorationsController.html#get_running_exploration/0","title":"MarsExplorer.ExplorationsController.get_running_exploration/0","type":"function"},{"doc":"Set the explorations grid","ref":"MarsExplorer.ExplorationsController.html#set_grid/1","title":"MarsExplorer.ExplorationsController.set_grid/1","type":"function"},{"doc":"Set the running exploration","ref":"MarsExplorer.ExplorationsController.html#set_running_exploration/1","title":"MarsExplorer.ExplorationsController.set_running_exploration/1","type":"function"},{"doc":"","ref":"MarsExplorer.ExplorationsController.html#start_link/1","title":"MarsExplorer.ExplorationsController.start_link/1","type":"function"},{"doc":"Updates the running exploration","ref":"MarsExplorer.ExplorationsController.html#update_running_exploration/1","title":"MarsExplorer.ExplorationsController.update_running_exploration/1","type":"function"},{"doc":"Module responsible for managing a highland grid","ref":"MarsExplorer.HighlandGrid.html","title":"MarsExplorer.HighlandGrid","type":"module"},{"doc":"Generates the highland grid Examples iex&gt; alias MarsExplorer.HighlandGrid MarsExplorer.HighlandGrid iex&gt; HighlandGrid . build ( %{ north : 5 , east : 5 } ) % HighlandGrid { north_limit : 5 , east_limit : 5 }","ref":"MarsExplorer.HighlandGrid.html#build/1","title":"MarsExplorer.HighlandGrid.build/1","type":"function"},{"doc":"Determines if a position would be within the highland grid's limits Examples iex&gt; alias MarsExplorer.HighlandGrid MarsExplorer.HighlandGrid iex&gt; grid = % HighlandGrid { north_limit : 5 , east_limit : 5 } % HighlandGrid { north_limit : 5 , east_limit : 5 } iex&gt; grid |&gt; HighlandGrid . valid_position? ( %{ north : 0 , east : 0 } ) true iex&gt; grid |&gt; HighlandGrid . valid_position? ( %{ north : 5 , east : 5 } ) true iex&gt; grid |&gt; HighlandGrid . valid_position? ( %{ north : 0 , east : 6 } ) false iex&gt; grid |&gt; HighlandGrid . valid_position? ( %{ north : 6 , east : 0 } ) false","ref":"MarsExplorer.HighlandGrid.html#valid_position?/2","title":"MarsExplorer.HighlandGrid.valid_position?/2","type":"function"},{"doc":"","ref":"MarsExplorer.HighlandGrid.html#t:t/0","title":"MarsExplorer.HighlandGrid.t/0","type":"type"},{"doc":"Module responsible for interpreting the exploration instructions","ref":"MarsExplorer.InstructionsInterpreter.html","title":"MarsExplorer.InstructionsInterpreter","type":"module"},{"doc":"Interprets instructions from a instructions list. Examples iex&gt; alias MarsExplorer.InstructionsInterpreter MarsExplorer.InstructionsInterpreter iex&gt; instructions = [ &quot;5 5&quot; , &quot;1 2 N&quot; , &quot;LMLMLMLMM&quot; , &quot;3 3 E&quot; , &quot;MMRMMRMRRM&quot; ] [ &quot;5 5&quot; , &quot;1 2 N&quot; , &quot;LMLMLMLMM&quot; , &quot;3 3 E&quot; , &quot;MMRMMRMRRM&quot; ] iex&gt; instructions |&gt; InstructionsInterpreter . interpret ( ) [ { :grid , %{ north : 5 , east : 5 } } , { :place , %{ north : 2 , east : 1 , direction : :north } } , [ :turn_left , :move , :turn_left , :move , :turn_left , :move , :turn_left , :move , :move ] , { :place , %{ north : 3 , east : 3 , direction : :east } } , [ :move , :move , :turn_right , :move , :move , :turn_right , :move , :turn_right , :turn_right , :move ] ]","ref":"MarsExplorer.InstructionsInterpreter.html#interpret/1","title":"MarsExplorer.InstructionsInterpreter.interpret/1","type":"function"},{"doc":"Module responsible for running the exploration instructions","ref":"MarsExplorer.InstructionsRunner.html","title":"MarsExplorer.InstructionsRunner","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MarsExplorer.InstructionsRunner.html#child_spec/1","title":"MarsExplorer.InstructionsRunner.child_spec/1","type":"function"},{"doc":"Run a set of exploration instructions Example iex&gt; instructions = [ { :grid , %{ north : 5 , east : 5 } } , { :place , %{ north : 0 , east : 0 , direction : :north } } , [ :move , :move ] ] [ { :grid , %{ north : 5 , east : 5 } } , { :place , %{ north : 0 , east : 0 , direction : :north } } , [ :move , :move ] ] iex&gt; MarsExplorer.InstructionsRunner . run instructions [ % MarsExplorer.Exploration { probe : % MarsExplorer.Probe { north : 2 , east : 0 , direction : :north } , grid : % MarsExplorer.HighlandGrid { north_limit : 5 , east_limit : 5 } } ]","ref":"MarsExplorer.InstructionsRunner.html#run/1","title":"MarsExplorer.InstructionsRunner.run/1","type":"function"},{"doc":"Module responsible for executing probe actions","ref":"MarsExplorer.Probe.html","title":"MarsExplorer.Probe","type":"module"},{"doc":"Moves the probe forward Examples iex&gt; alias MarsExplorer.Probe MarsExplorer.Probe iex&gt; probe = % Probe { north : 0 , direction : :north } % Probe { north : 0 , direction : :north } iex&gt; probe |&gt; Probe . move % Probe { north : 1 } iex&gt; probe |&gt; Probe . move |&gt; Probe . move % Probe { north : 2 }","ref":"MarsExplorer.Probe.html#move/1","title":"MarsExplorer.Probe.move/1","type":"function"},{"doc":"Turns the probe left Examples iex&gt; alias MarsExplorer.Probe MarsExplorer.Probe iex&gt; probe = % Probe { direction : :north } % Probe { direction : :north } iex&gt; probe |&gt; Probe . turn_left % Probe { direction : :west }","ref":"MarsExplorer.Probe.html#turn_left/1","title":"MarsExplorer.Probe.turn_left/1","type":"function"},{"doc":"Turns the probe right Examples iex&gt; alias MarsExplorer.Probe MarsExplorer.Probe iex&gt; probe = % Probe { direction : :north } % Probe { direction : :north } iex&gt; probe |&gt; Probe . turn_right % Probe { direction : :east }","ref":"MarsExplorer.Probe.html#turn_right/1","title":"MarsExplorer.Probe.turn_right/1","type":"function"},{"doc":"","ref":"MarsExplorer.Probe.html#t:t/0","title":"MarsExplorer.Probe.t/0","type":"type"}]